From dc4afb5580841720ea42bea7b3d4f18f1cd81760 Mon Sep 17 00:00:00 2001
From: Shinya Kato <shinya11.kato@gmail.com>
Date: Fri, 10 Jul 2026 17:15:44 +0900
Subject: [PATCH v4] doc: Clarify VERBOSE output for ANALYZE and VACUUM

ANALYZE VERBOSE and VACUUM VERBOSE both print per-table information
at INFO level, including the table currently being processed and
various statistics.  However, the documentation described ANALYZE
VERBOSE only as displaying generic "progress messages", while VACUUM
VERBOSE used different wording about a vacuum activity report.

Reword the VERBOSE option descriptions and Outputs sections to describe
the actual output more consistently.  Also update the VACUUM example
for VACUUM (VERBOSE, ANALYZE), since that command prints information
about both vacuuming and analyzing the table.

Author: Shinya Kato <shinya11.kato@gmail.com>
Reviewed-by: Maciek Sakrejda <m.sakrejda@gmail.com>
Reviewed-by: Fujii Masao <masao.fujii@gmail.com>
Reviewed-by: David G. Johnston <david.g.johnston@gmail.com>
Reviewed-by: Surya Poondla <suryapoondla4@gmail.com>
Reviewed-by: Yushu Chen <gentcys@gmail.com>
Reviewed-by: solai v <solai.cdac@gmail.com>
Discussion: https://postgr.es/m/CAOzEurTpMTUEW8kHu-zKB0EBtuPfpvyoJ--8pxKe87p24BGrpg@mail.gmail.com
---
 doc/src/sgml/ref/analyze.sgml | 10 ++++++----
 doc/src/sgml/ref/vacuum.sgml  | 14 ++++++++------
 2 files changed, 14 insertions(+), 10 deletions(-)

diff --git a/doc/src/sgml/ref/analyze.sgml b/doc/src/sgml/ref/analyze.sgml
index ec81f00fecf..d27c0d9e864 100644
--- a/doc/src/sgml/ref/analyze.sgml
+++ b/doc/src/sgml/ref/analyze.sgml
@@ -65,7 +65,8 @@ ANALYZE [ ( <replaceable class="parameter">option</replaceable> [, ...] ) ] [ <r
     <term><literal>VERBOSE</literal></term>
     <listitem>
      <para>
-      Enables display of progress messages at <literal>INFO</literal> level.
+      Prints detailed information about analyzing each table at
+      <literal>INFO</literal> level.
      </para>
     </listitem>
    </varlistentry>
@@ -167,9 +168,10 @@ ANALYZE [ ( <replaceable class="parameter">option</replaceable> [, ...] ) ] [ <r
   <title>Outputs</title>
 
    <para>
-    When <literal>VERBOSE</literal> is specified, <command>ANALYZE</command> emits
-    progress messages to indicate which table is currently being
-    processed.  Various statistics about the tables are printed as well.
+    When <literal>VERBOSE</literal> is specified, <command>ANALYZE</command>
+    prints detailed information about analyzing each table at
+    <literal>INFO</literal> level, including which table is currently
+    being processed and various statistics about the tables.
    </para>
  </refsect1>
 
diff --git a/doc/src/sgml/ref/vacuum.sgml b/doc/src/sgml/ref/vacuum.sgml
index 38ee973ea05..3c85846df26 100644
--- a/doc/src/sgml/ref/vacuum.sgml
+++ b/doc/src/sgml/ref/vacuum.sgml
@@ -115,8 +115,8 @@ VACUUM [ ( <replaceable class="parameter">option</replaceable> [, ...] ) ] [ <re
     <term><literal>VERBOSE</literal></term>
     <listitem>
      <para>
-      Prints a detailed vacuum activity report for each table
-      at <literal>INFO</literal> level.
+      Prints detailed information about vacuuming each table at
+      <literal>INFO</literal> level.
      </para>
     </listitem>
    </varlistentry>
@@ -419,9 +419,10 @@ VACUUM [ ( <replaceable class="parameter">option</replaceable> [, ...] ) ] [ <re
   <title>Outputs</title>
 
    <para>
-    When <literal>VERBOSE</literal> is specified, <command>VACUUM</command> emits
-    progress messages to indicate which table is currently being
-    processed.  Various statistics about the tables are printed as well.
+    When <literal>VERBOSE</literal> is specified, <command>VACUUM</command>
+    prints detailed information about vacuuming each table at
+    <literal>INFO</literal> level, including which table is currently
+    being processed and various statistics about the tables.
    </para>
  </refsect1>
 
@@ -501,7 +502,8 @@ VACUUM [ ( <replaceable class="parameter">option</replaceable> [, ...] ) ] [ <re
 
   <para>
    To clean a single table <structname>onek</structname>, analyze it for
-   the optimizer and print a detailed vacuum activity report:
+   the optimizer and print detailed information about vacuuming and
+   analyzing it:
 
 <programlisting>
 VACUUM (VERBOSE, ANALYZE) onek;
-- 
2.55.0